-- EmoteLDB by Cilraaz of Rexxar-US

EmoteLDB = LibStub("AceAddon-3.0"):NewAddon("EmoteLDB")

-- Set up environment variables
local _G = getfenv(0)

local string = _G.string
local pairs = _G.pairs
local gsub = string.gsub

-- Debug setting
debug = false

-- Declare Libs
local addon = EmoteLDB
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local QTC = LibStub('LibQTip-1.0')
local icon = LibStub("LibDBIcon-1.0")

-- Locale
local L = EMOTELDB_LOCALS

-- Frame
local QTC = LibStub('LibQTip-1.0')
local tooltip
local options
local frame = CreateFrame("Frame")
local EmoteLDBObj

local menuLevel = 1
local info = nil
local key = nil
local infoArray = {}
local keyArray = {}

-- DB Defaults
local defaults = {
	profile = {
		showSlashCommand = true,
		hideDetails = true
	},
	global = {
		LibDBIcon = { hide = false }
	}
}

addon.db = LibStub("AceDB-3.0"):New("EmoteLDBDB", defaults)

-- Local Functions
function addon:GetOnDemandText(v,hasTarget)
	local color
	local flag = nil
	local returnCode
	local emoteText

	if (hasTarget) then emoteText = v.target else emoteText = v.none end
	
	if (EL_Types[v["types"][1]] and EL_Types[v["types"][1]]=="Custom") then
		emtoeText = UnitName("player").." "..emoteText
	end

	if (EL_React[v.react] == "") then -- None
		color = "fffefefe"
	elseif (EL_React[v.react] == "A") then -- Animated, Purple
		color = "ffa335ee"
		flag = "A"
	elseif (EL_React[v.react] == "V") then -- Voice, Orange
		color = "ffff8000"
		flag = "V"
	elseif (EL_React[v.react] == "AV") then -- Both, Green
		color = "ff1eff00"
		flag = "AV"
	else -- Shouldn't happen, Grey
		color = "ff9d9d9d"
	end

	returnCode = "|c" .. color .. emoteText .. FONT_COLOR_CODE_CLOSE
	if (flag) then returnCode = returnCode.." ["..flag.."]" end
	return returnCode
end

local function HandleModClick(_, k)
	if (k) then
		if (EL_Types[EL_Emotes[k]["types"][1]] and EL_Types[EL_Emotes[k]["types"][1]]=="Custom") then -- Custom emote
			local emoteText
			local hasTarget = UnitName("target")
			local genderCode = UnitSex("player")
			local genderHe = nil
			local genderHis = nil
			local genderhe = nil
			local genderhis = nil
			if (genderCode == 2) then -- male
				genderHe = "He"
				genderHis = "His"
				genderhe = "he"
				genderhis = "his"
			else -- female (we hope)
				genderHe = "She"
				genderHis = "Her"
				genderhe = "she"
				genderhis = "her"
			end

			if (hasTarget) then
				emoteText = EL_Emotes[k].target
				emoteText = gsub(emoteText,"<Target>",hasTarget)
			else
				emoteText = EL_Emotes[k].none
			end
			
			emoteText = gsub(emoteText,"<He>",genderHe)
			emoteText = gsub(emoteText,"<His>",genderHis)
			emoteText = gsub(emoteText,"<he>",genderhe)
			emoteText = gsub(emoteText,"<his>",genderhis)

			SendChatMessage(emoteText,"EMOTE")
		else
			emoteToken = string.upper(k)
			if (emoteToken == "LAVISH") then
				emoteToken = "PRAISE";
			end
			if (emoteToken == "EXCITED") then
				emoteToken = "TALKEX";
			end
			if (emoteToken == "DOOM") then
				emoteToken = "THREATEN";
			end
			if (emoteToken == "SILLY") then
				emoteToken = "JOKE";
			end
			if (emoteToken == "LAY") then
				emoteToken = "LAYDOWN";
			end
			if (emoteToken == "REAR") then
				emoteToken = "SHAKE";
			end
			if (emoteToken == "BELCH") then
				emoteToken = "BURP";
			end
			if (emoteToken == "SMELL") then
				emoteToken = "STINK";
			end
			if (emoteToken == "GOODBYE") then
				emoteToken = "BYE";
			end
			if (emoteToken == "FOLLOWME") then
				emoteToken = "FOLLOW";
			end
			if (emoteToken == "ATTACKTARGET") then
				emoteToken = "ATTACKMYTARGET";
			end
			if (emoteToken == "CONGRATS") then
				emoteToken = "CONGRATULATE";
			end
			if (emoteToken == "PUZZLED") then
				emoteToken = "PUZZLE";
			end
			if (emoteToken == "QUESTION") then
				emoteToken = "TALKQ";
			end
			DoEmote(emoteToken);
		end
	end
end

-- Handler Function
local function HandlerFunc(_, name, button, ...)
	if name == "showSlash" then
		addon.db.profile.showSlashCommand = not addon.db.profile.showSlashCommand
	else
		local hasTarget = UnitName("target")
		local genderCode = UnitSex("player")
		local genderHe = nil
		local genderHis = nil
		local genderhe = nil
		local genderhis = nil
		if (genderCode == 2) then -- male
			genderHe = "He"
			genderHis = "His"
			genderhe = "he"
			genderhis = "his"
		else -- female (we hope)
			genderHe = "She"
			genderHis = "Her"
			genderhe = "she"
			genderhis = "her"
		end
		
		local i = 1

		for k, v in pairs(EL_Emotes) do
			for k2, v2 in pairs(v.types) do
				if (name == v2) then
					info = nil
					if (hasTarget) then
						info = addon:GetOnDemandText(v,true)
						info = gsub(info,"<Target>",hasTarget)
					else
						info = addon:GetOnDemandText(v,false)
					end

					info = gsub(info,"<He>",genderHe)
					info = gsub(info,"<His>",genderHis)
					info = gsub(info,"<he>",genderhe)
					info = gsub(info,"<his>",genderhis)

					for k3, v3 in pairs(v.custom) do
						if (v3 == 1) then
							slshCmd = "Custom:  "
						else
							slshCmd = "/"..k..":  "
						end
					end
			
					if (addon.db.profile.showSlashCommand) then
						infoArray[i] = slshCmd..info
						keyArray[i] = k
					else
						infoArray[i] = info
						keyArray[i] = k
					end
					i = i + 1
				end
			end
		end
		menuLevel = 2
	end
	addon:ShowTooltip(keyArray,infoArray,menuLevel)
end

-- Startup
EmoteLDBObj = ldb:NewDataObject("EmoteLDB", {
		type = "data source",
		icon = "Interface\\Icons\\Spell_Shadow_Charm",
		label = "EmoteLDB",
		text = "Emotes are fun!",
	})
	
function addon:OnInitialize()
	icon:Register("EmoteLDB", EmoteLDBObj, addon.db.global.LibDBIcon) -- Minimap
end

-- Tooltip
local function HideTooltip()
	if MouseIsOver(tooltip) then return end
	tooltip:SetScript("OnLeave", nil)
	QTC:Release(tooltip)
	tooltip = nil
end

function EmoteLDBObj.OnEnter(self)
	tooltip = QTC:Acquire("EmoteLDBTooltip", 2, "LEFT", "LEFT", "LEFT")
	tooltip:SmartAnchorTo(self)
	tooltip:SetAutoHideDelay(2, self)
	addon:ShowTooltip(key,info,menuLevel)
end

function EmoteLDBObj.OnLeave(self)
	HideTooltip()
end

function addon:ShowTooltip(key, info, menuLevel)
	tooltip:Clear()
	tooltip:SetScale(1)
	
	local headerFont = CreateFont("EmoteLDBHeaderFont")
	EmoteLDBHeaderFont:CopyFontObject(GameTooltipHeaderText)
	EmoteLDBHeaderFont:SetFont(EmoteLDBHeaderFont:GetFont(), 15)

	-- Display Header in tooltip
	local y = tooltip:AddLine()
	tooltip:SetCell(y, 1, "EmoteLDB", EmoteLDBHeaderFont, "CENTER", 2)
	tooltip:AddLine(" ")

	if (menuLevel < 2) then
		-- Display toggle option for slash commands
		local y = tooltip:AddLine()
		tooltip:SetCell(y, 1, "Toggle the showing of slash commands.", "CENTER", 2)
		tooltip:SetCellScript(y, 1, "OnMouseDown", HandlerFunc, "showSlash")
		local y = tooltip:AddLine()
		tooltip:SetCell(y, 1, "Currently: ", "RIGHT")
		tooltip:SetCell(y, 2, format("%s", addon.db.profile.showSlashCommand and "|c0000FF00Shown" or "|c00FF0000Hidden"), "LEFT")
		tooltip:AddLine(" ")

		-- Display initial menu
		for k, v in pairs(EL_Types) do
			local elType = k
			local label = v
		
			local y = tooltip:AddLine()
			tooltip:SetCell(y, 1, v, "CENTER", 2)
			tooltip:SetCellScript(y, 1, "OnMouseDown", HandlerFunc, k)
		end
	elseif (menuLevel == 2) and (info) and (key) then
		local infoCount = #info
		for i=1,infoCount do
			local y = tooltip:AddLine()
			tooltip:SetCell(y, 1, info[i], "CENTER")
			tooltip:SetCellScript(y, 1, "OnMouseDown", HandleModClick, key[i])
		end
	else
		-- Release tooltip and reset
		tooltip:Release()
		self.tooltip = nil
		menuLevel = 1
		return
	end

	tooltip:Show()
end
